.change-go-patterns: &change-go-patterns
  - "cmd/**/*"
  - "pkg/**/*"
  - ".gitlab/ci/go/**/*"
  - "manifests/**/*"
  - "deploy/**/*"

.common-manifests-ci-env-patterns: &common-manifests-ci-env-patterns
  - .gitlab/ci/image-build/template.yaml

.authenticator-image-build-patterns: &authenticator-image-build-patterns
  - cmd/authenticator/Dockerfile
.config-reloader-image-build-patterns: &config-reloader-image-build-patterns
  - cmd/config-reloader/Dockerfile

.if-merge-request: &if-merge-request
  if: '$CI_PIPELINE_SOURCE == "merge_request_event"'

.if-commit-master: &if-commit-master
  if: '$CI_COMMIT_REF_NAME == "master"'

.if-release-tag: &if-release-tag
  if: '$CI_COMMIT_TAG =~ /^v[0-9]+\.[0-9]+\.[0-9]+(-(rc|RC|beta)\d*)?$/'

# always run when someone create merge request
.merge_request_always_rules:
  rules:
    - <<: *if-merge-request
      when: always
    - <<: *if-release-tag
      when: never

# condition to run gotest
.run-test-rules:
  rules:
    - <<: *if-merge-request
      changes: *change-go-patterns
    - <<: *if-commit-master
      changes: *change-go-patterns
    - <<: *if-release-tag
      when: never

# condition to build conatiner image, registry.gitlab.com/kindaicvlab/cvcloud/authenticator:latest
.latest-image-build-rules:
  rules:
    - <<: *if-commit-master
      changes: *common-manifests-ci-env-patterns
    - <<: *if-commit-master
      changes: *authenticator-image-build-patterns
    - <<: *if-commit-master
      changes: *config-reloader-image-build-patterns
    - <<: *if-commit-master
      changes: *change-go-patterns
    - <<: *if-commit-master
      changes: [.gitlab/ci/image-build/build-authenticator.yaml]
    - <<: *if-release-tag
      when: never

# condition to build container image, registry.gitlab.com/kindaicvlab/cvcloud/authenticator:test
.test-image-build-rules:
  rules:
    - <<: *if-merge-request
      changes: *common-manifests-ci-env-patterns
    - <<: *if-merge-request
      changes: *authenticator-image-build-patterns
    - <<: *if-merge-request
      changes: *change-go-patterns
    - <<: *if-merge-request
      changes: [.gitlab/ci/image-build/test-build-authenticator.yaml]
    - <<: *if-release-tag
      when: never

# condition to release authenticator
.release-rules:
  rules:
    - <<: *if-release-tag
      when: always
